<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <script src="https://cdn.jsdelivr.net/npm/vue/dist/vue.js"></script>
</head>
<body>
    <div id="app_1">
        <my-component-1></my-component-1>
        <my-component-2></my-component-2>
    </div>

    <div id="app_2">
        <!-- html쪽에서는 모든 식별자를 소문자, 케밥 케이스로 참조해야 한다. -->
        <my-component-2 main-name="배성재" sub-name="Bae"></my-component-2>
    </div>

    <script>
        // Vue 전역에서 사용할 수 있는 컴포넌트를 등록한다.
        // 컴포넌트의 이름은 HTML 스펙에서 강제하는 소문자, 케밥(-) 기법을 따르지 않아도 되지만
        // 그래도 따라주는게 좋다고 오피셜에서는 말하고 있다.
        Vue.component('my-component-1', {
            template: `<div>Hello world</div>`
        });

        Vue.component('my-component-2', {
            template: `
                <div>
                    <!-- 글로벌 컴포넌트이기 때문에 다른 컴포넌트에서도 접근 가능 -->
                    <my-component-1></my-component-1>
                    <p>{{mainName}}</p>
                    <button @click="swapName">Click</button>
                </div>`,
            methods: {
                swapName() {
                    [this.mainName, this.subName] = [this.subName, this.mainName];
                },
            },
            props: {
                mainName: {
                    type: String, // 타입 여러개 설정하려면 [String, Number] 이런식으로 배열로
                    default: "홍길동", // 기본값 설정, type이 오브젝트나 배열일 경우 함수형식으로 구현해야 함
                },
                subName: {
                    type: String,
                    default: "Hong",
                },
            }
        });

        new Vue({
            el: "#app_1",
        });

        new Vue({
            el: "#app_2",
        });
    </script>
</body>
</html>